//-------------------------------------------------------------
//  Etasoft Inc. Forex EA and Script Generator version 4.1   EA
//-------------------------------------------------------------
// Keywords: MT4, Forex EA builder, create EA, expert advisor developer

#property copyright "Copyright  2011, Etasoft Inc. Forex EA Generator v4.1"
#property link      "sulaimoney"

#include <stdlib.mqh>
#include <WinUser32.mqh>

// exported variables
extern int OrderId = 1;
extern int Slippage = 2; 
extern double Lots = 0.01;
extern int MaxOrdersAllowed = 2;// op buy and op sell allowed
extern int Grid  = 10;  // total distance in pips to open  orders
 extern string EAComment = "564 testing";


// local variables
double PipValue=1;    // this variable is here to support 5-digit brokers
bool Terminated = false;
string LF = "\n";  // use this in custom or utility blocks where you need line feeds
int NDigits = 4;   // used mostly for NormalizeDouble in Flex type blocks
int ObjCount = 0;  // count of all objects created on the chart, allows creation of objects with unique names
int current = 0;

bool Executed6 = false;

int init()
{
    NDigits = Digits;
    
    if (false) ObjectsDeleteAll();      // clear the chart
    
    
    Comment("");    // clear the chart
    return(0);
}

// Expert start
int start()
{
    if (Bars < 10)
    {
        Comment("Not enough bars");
        return (0);
    }
    if (Terminated == true)
    {
        Comment("EA Terminated.");
        return (0);
    }
    
    OnEveryTick1();
   return(0);    
}

void OnEveryTick1()
{
    if (true == false && false) PipValue = 10;
    if (true && (NDigits == 3 || NDigits == 5)) PipValue = 10;
    
    IfNoOrderExist5();
    IfOrderExists6();
    MaximumOrder();
     
    
}
void IfNoOrderExist5()
{
    bool exists = false;
    for (int i=OrdersTotal()-1; i >= 0; i--)
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
        if (OrderSymbol() == Symbol())
        {
            exists = true;
        }
    }
    else
    {
        Print("OrderSelect() error - ", ErrorDescription(GetLastError()));
    }
    
    if (exists == false)
    {
       ExecuteOnce6();
        
        
    }
}
void ExecuteOnce6()
{
    
    
    
    
    if (Executed6 == false)
    {
        Executed6 = true;
        BuyPendingOrder();
        SellPendingOrder();
        
    }
}


 void BuyPendingOrder()
{
    int expire = TimeCurrent() + 60 * 0;
    double price = NormalizeDouble((Ask-((Ask-Bid)/2)), NDigits) + Grid*PipValue*Point;
    double SL = price - 0*PipValue*Point;
    if (0 == 0) SL = 0;
    double TP = price + 0*PipValue*Point;
    if (0 == 0) TP = 0;
    if (0 == 0) expire = 0;
    int ticket = OrderSend(Symbol(), OP_BUYSTOP, Lots, price,  Slippage, SL, TP, EAComment, OrderId, expire, Blue);
    if (ticket == -1)
    {
        Print("OrderSend() error - ", ErrorDescription(GetLastError()));
    }
     
}

void SellPendingOrder()
{
    int expire = TimeCurrent() + 60 * 0;
    double price = NormalizeDouble((Bid+((Ask-Bid)/2)), NDigits) - Grid*PipValue*Point;
    double SL = price + 0*PipValue*Point;
    if (0 == 0) SL = 0;
    double TP = price - 0*PipValue*Point;
    if (0 == 0) TP = 0;
    if (0 == 0) expire = 0;
    int ticket = OrderSend(Symbol(), OP_SELLSTOP, Lots, price, Slippage, SL, TP, EAComment, OrderId, expire, Red);
    if (ticket == -1)
    {
        Print("OrderSend() error - ", ErrorDescription(GetLastError()));
    }
    
}
void IfOrderExists6()
{
    bool exists = false;
    for (int i=OrdersTotal()-1; i >= 0; i--)
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
       if ((OrderType() == OP_BUY  || OrderType() == OP_SELL) && OrderSymbol() == Symbol() && OrderMagicNumber() == OrderId)
        {
            exists = true;
        }
    }
    else
    {
        Print("OrderSelect() error - ", ErrorDescription(GetLastError()));
    }
    
    if (exists)
    {
      // IfOrderDoesNotExist7();
       IfOrderDoesNotExist5();      
            
    }
}


void IfOrderDoesNotExist5()
{
    bool exists = false;
    for (int i=OrdersTotal()-1; i >= 0; i--)
       if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
            exists = (OrderType() == OP_BUYSTOP && OrderSymbol() == Symbol() && OrderMagicNumber() == OrderId);
       else Print("OrderSelect() error - ", ErrorDescription(GetLastError()));
    
    if (exists == false) NewBuyStopPending();
}

void IfOrderDoesNotExist7()
{
    bool exists = false;
    for (int i=OrdersTotal()-1; i >= 0 && !exists; i--)
       if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
            exists = (OrderType() == OP_SELLSTOP && OrderSymbol() == Symbol() && OrderMagicNumber() == OrderId);
       else Print("OrderSelect() error - ", ErrorDescription(GetLastError()));
    
    if (exists == false) NewSellStopPending();      
}
  

 
void NewBuyStopPending()
{   
    int LOprice1 = 0;
    datetime lastTime  = 0;
    datetime closeTime  = 0;
    int      lastTicket = -1; // None open.      
    for (int i=OrdersTotal()-1; i >= 0; i--) 
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {     
        
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == OrderId 
        && OrderOpenTime() >= lastTime && OrderCloseTime() == closeTime
        && OrderTicket() > lastTicket )
        {          
             lastTime   = OrderOpenTime(); 
             LOprice1 = OrderOpenPrice();
             closeTime   = OrderCloseTime();            
             lastTicket = OrderTicket();            
             
             
            if (   OrderType() == OP_BUY  || OrderType() == OP_SELL )
             {
              
                { 
                  
                  BuyPendingOrder1();                                            
                    
                }
            }
            
        }
        return;
    }
    else
    Print("OrderSelect() error - ", ErrorDescription(GetLastError()));
    
}
void NewSellStopPending()
{   
    int LOprice1 = 0;
    datetime lastTime  = 0;
    datetime closeTime  = 0;
    int      lastTicket = -1; // None open.      
    for (int i=OrdersTotal()-1; i >= 0; i--) 
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {     
        
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == OrderId 
        && OrderOpenTime() >= lastTime && OrderCloseTime() == closeTime
        && OrderTicket() > lastTicket )
        {          
             lastTime   = OrderOpenTime(); 
             LOprice1 = OrderOpenPrice();
             closeTime   = OrderCloseTime();            
             lastTicket = OrderTicket();            
            
             
            if (   OrderType() == OP_BUY  || OrderType() == OP_SELL )
             {
              
                { 
                  
                  SellPendingOrder1();                                      
                    
                }
            }
            
        }
        return;
    }
    else
    Print("OrderSelect() error - ", ErrorDescription(GetLastError()));
    
}
 
 void BuyPendingOrder1()
{
     
    int expire = TimeCurrent() + 60 * 0;
    double price = NormalizeDouble( Ask , NDigits) + (Grid )*PipValue*Point;
    double LOprice1 = OrderOpenPrice() + (Grid)*PipValue*Point;
    double SL = price - 0*PipValue*Point;
    if (0 == 0) SL = 0;
    double TP = price + 0*PipValue*Point;
    if (0 == 0) TP = 0;
    if (0 == 0) expire = 0;
    int ticket = OrderSend(Symbol(), OP_BUYSTOP, Lots, LOprice1,  Slippage, SL, TP, EAComment, OrderId, expire, Blue);
    if (ticket == -1)
    {
        Print("OrderSend() error - ", ErrorDescription(GetLastError()));
    }
    
}

void SellPendingOrder1()
{
   
    int expire = TimeCurrent() + 60 * 0;
    double price = NormalizeDouble( Bid , NDigits) - (Grid )*PipValue*Point;
    double LOprice1 = OrderOpenPrice() - (Grid )*PipValue*Point;
    double SL = price + 0*PipValue*Point;
    if (0 == 0) SL = 0;
    double TP = price - 0*PipValue*Point;
    if (0 == 0) TP = 0;
    if (0 == 0) expire = 0;
    int ticket = OrderSend(Symbol(), OP_SELLSTOP, Lots, LOprice1, Slippage, SL, TP, EAComment, OrderId, expire, Red);
    if (ticket == -1)
    {
        Print("OrderSend() error - ", ErrorDescription(GetLastError()));
    }
    
}

void MaximumOrder()
{
    if (MaxOrdersAllowed> 0)
    {
         OrderCount();
        
    }
}

void  OrderCount()
{
    int count = 0;
    for (int i=OrdersTotal()-1; i >= 0; i--)
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
        if (OrderSymbol() == Symbol())
        if (OrderMagicNumber() == OrderId)
       if (OrderType() == OP_BUY || OrderType() == OP_SELL)
        {
            count++;
        }
    }
    else
    {
        Print("OrderSend() error - ", ErrorDescription(GetLastError()));
    }
    if (count > MaxOrdersAllowed )
    {
        DeleteOldestOrder();
       
    }
}

void DeleteOldestOrder()
{
   datetime lastTime   =  Time[0]+Period()*60;
   int      lastTicket = -1; // None open.
   for (int i=OrdersTotal()-1; i >= 0; i--)
   {
      if (!OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) continue;
      if ((OrderType() == OP_BUY || OrderType() == OP_SELL)
       && OrderSymbol() == Symbol() && OrderMagicNumber() == OrderId 
       && OrderOpenTime() <= lastTime)
      {
         lastTime = OrderOpenTime();
         lastTicket = OrderTicket();
      }
   }
   if (lastTicket>-1)
   if (OrderSelect(lastTicket,SELECT_BY_TICKET,MODE_TRADES))
       OrderClose(OrderTicket(),OrderLots(), OrderClosePrice(),Slippage,Red);
}

 
int deinit()
{
    if (false) ObjectsDeleteAll();
    
   return(0);    
}


